<template>
	<view class="p-content">
		<view class="p-head" v-if="baseData">
			<view>
				<text>销售单号：</text>
				<text style="color: crimson;">{{baseData.salesBillNo}}</text>
			</view>
			<view>
				<text>条码：</text>
				<view>
					<input
					@blur="queryProduct"
					style="width: 100%;text-align: left;" 
					class="uni-input" 
					placeholder="扫描或输入条码" 
					border="surround" 
					v-model="code">
				</view>
			</view>
			<view style="justify-content: flex-start;flex-wrap: wrap;">
				<view>总款数:123</view>
				<view>已检款数: 50</view>
			</view>
			<view style="justify-content: flex-start;flex-wrap: wrap;">
				<view>总数量: 150</view>
				<view>已检数量: 70</view>
			</view>
		</view>
		<view class="p-body">
			<uni-table style="width: 100%;" border emptyText="暂无数据" :loading="loading" >
				<!-- 表头行 -->
				<uni-tr>
					<uni-td align="center">产品编码</uni-td>
					<uni-td align="center">产品分类</uni-td>
					<uni-td align="center">已检/总数</uni-td>
					<uni-td align="center">检货</uni-td>
				</uni-tr>
				<!-- 表格数据行 -->
				<uni-tr v-for="item in detailList" :key="item.id" :checkedRow="curProduct&&curProduct.qrCode == item.qrCode">
					<uni-td width="30%" align="center">{{item.dealerProductEntity.code}}</uni-td>
					<uni-td width="30%" align="center">{{item.dealerProductEntity.productTypeName2}}</uni-td>
					<uni-td width="25%" align="center"><text style="color: red;">{{item.qty}}</text>/{{item.qty}}</uni-td>
					<uni-td width="15%" align="center">
						<!-- <text :style="{color:item.pickFlag==1?'green':'red'}">{{item.pickFlag==1?'已检货':'未检货'}}</text> -->
						<view style="display: flex;justify-content: center;">
							<u-icon v-if="item.pickFlag==0" name="close-circle-fill" color="red" size="22"></u-icon>
							<u-icon v-if="item.pickFlag==1" name="checkmark-circle-fill" color="green" size="22"></u-icon>
						</view>
					</uni-td>
				</uni-tr>
			</uni-table>
		</view>
		<view class="p-footer">
			<button :disabled="loading" size="mini" type="primary" @click="toOut"> 出库 <text class="iconfont icon-icon-test43"></text></button>
		</view>
		<scanCode></scanCode>
	</view>
</template>

<script>
	import scanCode from '@/libs/scan-code.vue';
	import { salesDetail, salesDetailList, salesPick, salesWriteStockOut, salesWriteNoStockOut } from '@/config/api.js'
	import { playAudio } from '@/libs/tools.js'
	export default {
		components: { scanCode },
		data() {
			return {
				loading: false,
				baseData: null,
				detailList:[],
				code:'',
				salesBillSn: null,
				salesId: null,
				curProduct: null
			};
		},
		onLoad(opts) {
		  var _this = this
		  this.salesBillSn = opts.salesBillSn
		  this.salesId = opts.id
		  this.getDetail()
		  this.getDetailList()
		  
		  uni.$on('scancodedate', function(content) {
			  console.log("扫描到的内容为:", content)
			  _this.code = content||''
			  _this.queryProduct()
		  })
		},
		onShow() {
			this.hideKeyborder()
		},
		onUnload() {
			uni.$off('scancodedate')
		},
		methods: {
			hideKeyborder(){
				uni.hideKeyboard()
			},
			//检货
			queryProduct(){
				if(this.code==''){return}
				this.loading = true
				salesPick({salesBillSn: this.salesBillSn, productQrCode: this.code}).then(res => {
					console.log(res)
					if(res.status == 200){
						if(res.data){
							this.getDetailList()
						}else{
							uni.$u.toast("此商品不存在")
							playAudio('error')
						}
					}
					this.loading = false
				})
			},
			// 详情
			getDetail(){
				salesDetail({salesBillSn: this.salesBillSn}).then(res => {
					console.log(res,'详情')
					if(res.status == 200){
						this.baseData = res.data
					}
				})
			},
			// 产品明细列表
			getDetailList(){
				salesDetailList({pageNo:1,pageSize:1000,salesBillSn:this.salesBillSn,orderBy: 'sales_bill_detail.CREATE_DATE desc'}).then(res => {
					if(res.status == 200){
						this.detailList = res.data.list
						const curProduct = this.detailList.find(item => item.qrCode == this.code)
						this.curProduct = curProduct || null
					}
				})
			},
			// 未捡货出库
			toNoOut(){
				const _this = this
				uni.showModal({
					title: '提示',
					content: '确定未检货出库？',
					success: function (res) {
						if (res.confirm) {
						}
					}
				});
			},
			// 出库
			async toOut(){
				const ret = await salesWriteStockOut({salesBillSn: this.salesBillSn})
				if(ret.status == 200){
					this.$store.state.vuex_isRefash = true
					uni.navigateBack()
				}
			}
		},
	}
</script>

<style lang="scss">
	.p-content{
		.p-head{
			font-size: 32upx;
			color: $uni-text-color;
			>view{
				display: flex;
				align-items: center;
				padding: 10upx 20upx;
				border-bottom: 1px solid #eee;
				> view{
					display: flex;
					padding: 0 10upx;
					align-items: center;
				}
			}
			.uni-input{
				border: 1px solid #eee;
				width: 150upx;
				text-align: center;
				padding: 8upx;
			}
		}
		.p-body{
			overflow: auto;
			flex-grow: 1;
			height: 50%;
		}
		.p-footer{
			padding:30upx;
			display: flex;
			> button{
				width: 40%;
			}
		}
	}
</style>
